<template>
  <v-container>
    <v-row>
      <v-col cols="6">
        <v-card
            class="mx-auto"
        >
          <v-card-text>
            <div>ALL GPON</div>
            <p class="display-1 text--primary" v-text="count_gpons" />
            <div class="text--primary" v-text="`TOTAL ALL GPON`"/>
          </v-card-text>
        </v-card>
      </v-col>
      <v-col cols="6">
        <v-card
            class="mx-auto"
        >
          <v-card-text>
            <div>VENDOR</div>
            <p class="display-1 text--primary" v-text="count_vendors" />
            <div class="text--primary" v-text="`TOTAL VENDOR`"/>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="3" v-for="vendor in vendors" :key="vendor.vendor">
        <v-card
            class="mx-auto"
        >
          <v-card-text>
            <div v-text="vendor.vendor">Word of the Day</div>
            <p class="display-1 text--primary" v-text="vendor.count">
            </p>
            <div class="text--primary" v-text="`TOTAL GPON ${vendor.vendor}`">
            </div>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <v-data-table
            :headers="headers"
            :items="logs"
            :search="search"
            :custom-filter="doSearch"
            :single-expand="singleExpand"
            :expanded.sync="expanded"
            item-key="id"
            show-expand
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:expanded-item="{ headers, item }">
            <td :colspan="headers.length">
              <div v-if="item.logConfigDetails">
                <div v-for="logconfig in item.logConfigDetails" :key="logconfig.id">
                  <v-container>
                    <pre>
                    {{ logconfig.cmd }} </pre>
                    <pre>{{ logconfig.result }}</pre>
                  </v-container>
                </div>
              </div>
            </td>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import nmsService from "../service/NmsService";
import gponService from "../service/GponService"
import logConfigService from "../service/LogConfigService";

export default {
  name: "Dashboard",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      vendors: [],
      count_gpons: 0,
      count_vendors: 0,
      expanded: [],
      singleExpand: true,
      search: '',
      logs: [],
      logsDetail: [],
      title: null,
      headers:[
        {text: "ID", align: "center", value: "id", sortable: true},
        {text: "TARGET", align: "center", value: "target", sortable: true},
        {text: "ACTION", align: "center", value: "action", sortable: true},
        {text: "STATUS", align: "center", value: "status", sortable: true},
        {text: "IP CLIENT", align: "center", value: "ip_client", sortable: true},
        {text: "START TIME", align: "center", value: "start_time", sortable: true},
        {text: "STOP TIME", align: "center", value: "stop_time", sortable: true},
        { text: '', value: 'data-table-expand' },
      ],
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    async doRefresh(){
      this.statusProgress = true
      await nmsService.getVendor().then(async resp => {
        let res = resp.data
        if (res.status === 'SUCCESS') {
          let vendors = res.data
          this.count_vendors = vendors.length
          for (let i in vendors) {
            await gponService.getVendor(vendors[i]).then(result => {
              let data = result.data
              if (data.status === 'SUCCESS') {
                let vendor = {
                  vendor: vendors[i],
                  count: data.data.length
                }
                this.vendors.push(vendor)
                this.count_gpons += vendor.count
              } else {
                let vendor = {
                  vendor: vendors[i],
                  count: 0
                }
                this.vendors.push(vendor)
              }
            })
          }
        }
      })

      await logConfigService.getLimit(10)
          .then(res => {
            this.logs = res.data.data
          })
          .catch(err => {
            console.log(err)
            console.log(err.response)
          })
      this.statusProgress = false
    },
  },
  created() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>